package com.zd.laboratory.service;

import com.zd.common.core.domain.R;
import com.zd.laboratory.domain.LabSubjectAccessRecord;
import com.zd.laboratory.domain.vo.LabSubjectAccessRecordVo;

import java.util.List;
import java.util.Map;

/**
 * 实验室进出记录Service接口
 *
 * @author zd
 * @date 2021-08-30
 */
public interface ILabSubjectAccessRecordService {
    /**
     * 查询实验室进出记录
     *
     * @param id 实验室进出记录主键
     * @return 实验室进出记录
     */
    public LabSubjectAccessRecord selectLabSubjectAccessRecordById(Long id);
    /**
     * 检查完成更新记录
     *
     * @param id id
     * @return 结构
     */
    public boolean updateCheck(Long id);
    /**
     * 查询实验室进出记录列表
     *
     * @param labSubjectAccessRecord 实验室进出记录
     * @return 实验室进出记录集合
     */
    public List<LabSubjectAccessRecordVo> selectLabSubjectAccessRecordList(LabSubjectAccessRecordVo labSubjectAccessRecord);

    /**
     * 查询实验室进出记录列表- 无权限
     *
     * @param labSubjectAccessRecord 实验室进出记录
     * @return 实验室进出记录集合
     */
    public List<LabSubjectAccessRecordVo> selectLabSubjectAccessRecordListNoAuth(LabSubjectAccessRecordVo labSubjectAccessRecord);


    /**
     * 查询我的实验室进出记录列表
     *
     * @param labSubjectAccessRecord 实验室进出记录
     * @return 实验室进出记录集合
     */
    public List<LabSubjectAccessRecordVo> selectMyAccessRecordList(LabSubjectAccessRecordVo labSubjectAccessRecord);


    /**
     * 新增实验室进出记录
     *
     * @param labSubjectAccessRecord 实验室进出记录
     * @return 结果
     */
    public long insertLabSubjectAccessRecord(LabSubjectAccessRecord labSubjectAccessRecord);

    /**
     * 修改实验室进出记录
     *
     * @param labSubjectAccessRecord 实验室进出记录
     * @return 结果
     */
    public int updateLabSubjectAccessRecord(LabSubjectAccessRecord labSubjectAccessRecord);

    /**
     * 批量删除实验室进出记录
     *
     * @param ids 需要删除的实验室进出记录主键集合
     * @return 结果
     */
    public int deleteLabSubjectAccessRecordByIds(Long[] ids);

    /**
     * 删除实验室进出记录信息
     *
     * @param id 实验室进出记录主键
     * @return 结果
     */
    public int deleteLabSubjectAccessRecordById(Long id);

    /**
     * 统计人员出入实验室次数(以日为单位)。
     *
     * @return 统计人员出入实验室次数
     */
    public List<LabSubjectAccessRecordVo> labInoutTime(LabSubjectAccessRecordVo labSubjectAccessRecordVo);

    /**
     * 查询实验室进出记录
     *
     * @param id 实验室进出记录主键
     * @return 实验室进出记录
     */
    public LabSubjectAccessRecordVo myAccessDetail(Long id);

    /**
     * 定时器定时查询离开时间超过24小时，记违规
     *
     * @return 结果
     */
    public int outTimeRecord();

    /**
     * 离开实验室打卡
     *
     * @param subId
     * @param userId
     * @return
     */
    public Boolean out(Long subId, Long userId);

    /**
     * 是否有正常签到记录
     *
     * @param subId
     * @param userId
     * @return
     */
    public Boolean isSigIn(Long subId, Long userId);

    /**
     * 获取当前用户最新的一条未关闭签到数据
     * @param userId
     * @param userId
     * @return
     */
    public LabSubjectAccessRecordVo isSigInAndGet(Long userId);


    /**
     * 获取离开实验室拍照附件列表
     * @param userId
     * @param userId
     * @return
     */
    public List<LabSubjectAccessRecordVo> isSigInAndGetList(Long userId);

    /**
     * 获取当前用户最新的一条未关闭签到数据
     * @param userId
     * @param userId
     * @return
     */
    public LabSubjectAccessRecordVo isSigInAndGet(Long userId,Long subjectId);

    Map<String, Object> recordStatistics();

    /**
     * 离开实验室未打卡，再次进入其他实验室打卡，记违规
     *
     * @return 结果
     */
    public long leaveAgainSign(LabSubjectAccessRecordVo labSubjectAccessRecord);

    R addRecord(Map map);

    public int getRecordNoOut(Long userId);

    /**
     * 更新签到记录
     * @param accessRecord
     * @return
     */
    int updateLabSubjectAccessRecordById(LabSubjectAccessRecord accessRecord);
}
